/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized. This
* software is owned by Renesas Electronics Corporation and is protected under
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer*
* Copyright (C) 2013 Renesas Electronics Corporation. All rights reserved.
******************************************************************************/
/*******************************************************************************
* File Name : iodefine.h
* $Rev: 1183 $
* $Date:: 2013-09-10 18:26:15 +0900#$
* Description : Definition of I/O Register (V0.61a)
******************************************************************************/
#ifndef _IODEFINE_H_
#define _IODEFINE_H_

#include "typedefine.h"
#include <stdint.h>

enum iodefine_byte_select_t {
    L = 0, H = 1,
    LL= 0, LH = 1, HL = 2, HH = 3
};

/* ->MISRA 18.4 : Pack unpack union */ /* ->SEC M1.6.2 */
/* ->SEC M1.10.1 : Not magic number */
union iodefine_reg32_t
{
    volatile uint32_t  UINT32;                                  /*  32-bit Access   */
    volatile uint16_t  UINT16[2];                               /*  16-bit Access   */
    volatile uint8_t   UINT8[4];                                /*  8-bit Access    */
};

union iodefine_reg32_16_t
{
    volatile uint32_t  UINT32;                                  /*  32-bit Access   */
    volatile uint16_t  UINT16[2];                               /*  16-bit Access   */
};
/* <-SEC M1.10.1 */
/* <-MISRA 18.4 */ /* <-SEC M1.6.2 */





#include "iodefines/spibsc_iodefine.h"
#include "iodefines/bsc_iodefine.h"
#include "iodefines/l2c_iodefine.h"
#include "iodefines/romdec_iodefine.h"
#include "iodefines/adc_iodefine.h"
#include "iodefines/scif_iodefine.h"
#include "iodefines/scim_iodefine.h"
#include "iodefines/rspi_iodefine.h"
#include "iodefines/spdif_iodefine.h"
#include "iodefines/irda_iodefine.h"
#include "iodefines/mlb_iodefine.h"
#include "iodefines/rscan0_iodefine.h"
#include "iodefines/dmac_iodefine.h"
#include "iodefines/intc_iodefine.h"
#include "iodefines/ether_iodefine.h"
#include "iodefines/usb20_iodefine.h"
#include "iodefines/scux_iodefine.h"
#include "iodefines/ssif_iodefine.h"
#include "iodefines/ceu_iodefine.h"
#include "iodefines/wdt_iodefine.h"
#include "iodefines/cpg_iodefine.h"
#include "iodefines/inb_iodefine.h"
#include "iodefines/gpio_iodefine.h"
#include "iodefines/lin_iodefine.h"
#include "iodefines/ostm_iodefine.h"
#include "iodefines/riic_iodefine.h"
#include "iodefines/ieb_iodefine.h"
#include "iodefines/mtu2_iodefine.h"
#include "iodefines/rtc_iodefine.h"
#include "iodefines/vdc5_iodefine.h"
#endif
