
MEMORY {
	ROM   (rx)  : ORIGIN = 0x04000000, LENGTH = 2M		/* On-Board Serial-FLASH ROM */
	SDRAM (rw)  : ORIGIN = 0x0C000000, LENGTH = 32M		/* On-Board SD-RAM */
	L_TTB (rw)  : ORIGIN = 0x20000000, LENGTH = 16K		/* Page 0 of On-Chip Data Retention RAM */
	SRAM  (rwx) : ORIGIN = 0x20020000, LENGTH = 3M - 128K
	SRAM_M(rwx) : ORIGIN = 0x60200000, LENGTH = 1M
}

SECTIONS
{
	.TTB : {
		Image$$TTB$$ZI$$Base = .;
		. += 0x00004000;
		Image$$TTB$$ZI$$Limit = .;
	} > L_TTB

	.text : {

		Image$$VECTORS$$Base = .;
		* (RESET)
		Image$$VECTORS$$Limit = .;
		. += 0x00000400;

		Image$$CODE_RDRV$$Base = .;

		* (SVC_TABLE)
		* (CODE_RESET)				/* for INITSCT() */
		* (.text .text.*)
		Image$$CODE_RDRV$$Limit = .;

		. = ALIGN(0x100000);		/* separate Code and Data. */
		* (.rodata .rodata.*)

	} > SRAM

	.data ALIGN(0x1000): {
		. = ALIGN(0x1000);		/* separate .rodata and .data/bss. */
		* (.data .data.*)

	} > SRAM

	.bss : {
		__bss_start = .;

		* (.bss .bss.*)

		* (COMMON)

		__bss_end = .;
		end = .;

	} > SRAM

	.heap ALIGN(0x1000) (NOLOAD) : {
		__heap_start = .;
		. += 0x40000;				/* for malloc heap */
		* (HEAP)
		__heap_end = .;
	} > SRAM

	.stack (NOLOAD) : {
		. = 0x00000000;
		* (STACK)
	} > SRAM

	.sdram (NOLOAD) : {
		Image$$SDRAM_DATA_RDRV$$Base = .;
		* (SDRAM)
		Image$$SDRAM_DATA_RDRV$$Limit = .;
	} > SDRAM

	.nc_data_mirror : {
		. = ALIGN(0x040000);		/* separate cache data and non-cache data. */
		Image$$NC_DATA_MIRROR_RDRV$$Base = .;
		* (NC_DATA)
		Image$$NC_DATA_MIRROR_RDRV$$Limit = .;
	} > SRAM_M
}
